package pruebasGaleShapley;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * Clase que lee dos archivos con elementos de dos grupos y sus parejas preferidas por orden, más otro archivo
 * con unas parejas formadas.
 * Comprueba si las parejas son estables según esas preferencias dadas 
 * @author Alberto Hueso Alonso
 *@since 07/12/2017
 *@see Funciones#leerElementoPreferencias(String)
 *@see Funciones#leerParejasEstablesFile(String)
 *@see Funciones#checkParejas(Map, Map, Map)
 */
@SuppressWarnings("rawtypes")
public class CheckParejasFiles {
	/**
	 * Parejas a examinar	
	 */
	static  Map  emparejados=new HashMap();			//Parejas a examinar
	/**
	 * //Elementos y preferencias del primer grupo
	 */
	static Map<String,ArrayList> elementosX=null;	
	/**
	 * /Elementos y preferencias del segundo grupo
	 */
	static Map<String, ArrayList> elementosY=null;	
	
	/**Acción de la clase CheckParejasFile
	 * lee dos archivos con elementos de dos gruposy sus parejas preferidas por orden, más otro archivo
	 * con unas parejas formadas.
	 * Comprueba si las parejas son estables según esas preferencias dadas 
	 * @param args  nombres de tres archivos, preferencias del primer grupo, preferencias del segundo grupo y archivo con las parejas
	 */
	public static void main(String[] args) {
		
		
		
		//Inicializamos los nombres de los archivos
		String xFile=null;
		String yFile=null;
		String parejasFile=null;
		
		//Tratamos de leer los argumentos	
		try{	
		 xFile=args[0];
		 yFile=args[1];
		 parejasFile=args[2];
		}catch (IndexOutOfBoundsException e){
			System.out.println("No se han encontrado argumentos\nSe intentarán leer los archivos por defecto");
		}	
		//Leemos los archivos
		try {
			if (xFile!=null&&yFile!=null&&parejasFile!=null){
				elementosX=Funciones.leerElementoPreferencias(xFile);
				elementosY=Funciones.leerElementoPreferencias(yFile);
				emparejados=Funciones.leerParejasEstablesFile(parejasFile);
				System.out.println("Leídos los argumentos: "+xFile+", "+yFile+" y "+parejasFile);
				
			//Si no se han podido leer los archivos se leen los nombres por defecto
			}else {
				elementosX=Funciones.leerElementoPreferencias("elementosX.out");
				elementosY=Funciones.leerElementoPreferencias("elementosY.out");
				emparejados=Funciones.leerParejasEstablesFile("parejas.txt");
				System.out.println("Leídos los archivos por defecto: elementosX.out, elementosY.out y parejas.txt");
			}
			
			//Mostramos sus preferencias
			Funciones.verPreferencias(elementosX,elementosY);
			
			System.out.println("Parejas estables del fichero:");
			//Mostramos las parejas estables
			Funciones.verParejas(emparejados, "PAREJAS ESTABLES:\n");
			
					
			//Comprobamos si son estables o no
			Funciones.checkParejas(emparejados, elementosX, elementosY);

		} catch (IOException e) {
			System.err.println("Ha habido algún problema en la lectura de los archivos\n"+e.getMessage());
		}
			
			 
			}

}
