package pruebasGaleShapley;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Clase que guarda funciones auxiliares
 * @author Alberto Hueso Alonso
 *@since 06/12/2017
 */
@SuppressWarnings("rawtypes")
public  class Funciones {
	
	/**
 * Comprueba que un mapa de emparejados sea estable respecto a las preferencias de otros dos 
 * mapas elementosX y elementosY
 * @param emparejados Map que guarda las parejas formadas que se quieren comprobar
 * @param elementosX  Map que guarda los elementosX con sus preferencias respecto a los elementos Y
 * @param elementosY  Map que guarda los elementosY con sus preferencias respecto a los elementos Y
 */
public static void checkParejas(Map emparejados, Map elementosX, Map elementosY){
System.out.println("COMPROBACIÓN DE PAREJAS");
int errores=0;
if (emparejados.size()!=elementosX.size()&&emparejados.size()!=elementosY.size())
{
	System.err.println("ATENCIÓN: Los tamaños de los datos no coinciden, compruebe que la lista de parejas corresponde a las listas de preferencias");

}else{
	
Iterator i=emparejados.keySet().iterator();
	Map emparejadosInver=obtenerInvers(emparejados);
	//Recorremos los diferentes Y (elegidos)
	while (i.hasNext()){
		
		//Obtenemos para el Y elegido el X correspondiente
		String Y = (String) i.next();
		String X=(String) emparejados.get(Y);
		
		 
	    //Obtenemos la posición de la pareja Y en la lista de X
		ArrayList listaX=(ArrayList) elementosX.get(X);
		int posElegida = listaX.indexOf(Y);		
		
		
				
		int contador=0;
				//Recorremos para este X todas sus Y por orden de preferencia
				while (contador<listaX.size()){
					
					String yActual=(String) listaX.get(contador);
					
					 ArrayList listaActual=  (ArrayList) elementosY.get(yActual);
					int posElector=listaActual.indexOf(X);
					String parejaY=(String) emparejadosInver.get(yActual);
					int posParejaY = listaActual.indexOf(parejaY);
					
					//Inicializamos los mensajes
					String msg="";
					String msg2="";
									
					//El Y actual prefiere al X de la iteración
					if (posParejaY>posElector){
						msg="\t"+yActual+", prefiere a "+X;
						
						//El X prefiere a su pareja al Y actual
						if(posElegida<contador){
							msg=msg.concat(" pero este prefiere a su pareja "+Y);
						}
						// El X prefiere a la Y actual también
						else {
							msg=msg.concat(" y este prefiere también a "+yActual);
						}
							
						
						
					}	else {
						//Si ya están emparejados
						if(posParejaY==posElector){
							 msg="\t"+yActual+" ya está emparejado con "+X;
						}//Si el Y actual prefiere a su pareja actual al X de la iteración
						else{
						msg="\t"+yActual+" no quiere emparejarse con "+X;
						msg=msg.concat(", prefiere a "+parejaY);
						}
					}
					System.out.println(msg);
					
					//El X de la iteración prefiere al Y actual
					if (posElegida>contador){
						 msg2="\t"+X+", prefiere a "+yActual;
						
						//El Y actual prefiere a su pareja
						if(posParejaY<posElector){
							msg2=msg2.concat(" pero este prefiere a su pareja "+parejaY);
						}
						//El Y actual también le prefiere
						else {
							msg2=msg2.concat(" y este prefiere también a "+X);
						}
							
						
					//El X de la iteracion no prefiere al Y actual	
					}else {
						if(posElegida==contador){
							//Ya están emparejados
						}else{
						msg2="\t"+X+" no quiere emparejarse con "+yActual;
						msg2=msg2.concat(", prefiere a "+Y);
						}
					}
					System.out.println(msg2);
					
					//Pareja que se prefiere entre sí antes que con quienes están
					if (posParejaY>posElector&&posElegida>contador){
						
						System.err.println("\nERROR: "+yActual+" y "+X+" preferirían estar juntos antes que con quienes están "+parejaY+", "+Y+"\n");
						errores++;
					}
					//System.out.println(mensaje+"\n");
					System.out.println();
					contador++;
				}
		}
}
System.out.println("Errores encontrados: "+errores);
}

/**
 * Intercambia claves y valores de un mapa
 * @param mapa
 * @return mapa con las claves y valores invertidos
 */
@SuppressWarnings("unchecked")
private static Map obtenerInvers(Map mapa)	{
	
	Map inverso=new HashMap();
	
	Iterator i=mapa.keySet().iterator();
	
	while (i.hasNext()){
		Object clave = i.next();
		Object valor=mapa.get(clave);
		inverso.put(valor, clave);
	}
	return mapa;
}

/**
 * <p>Función que lee un archivo<p>
 * <p>Se espera un archivo en el que cada línea siga la expresión regular [\\w]+:[\\w,]+</p>
 * <p>Es decir, una cadena, seguida de ":" seguida de cadenas de caracteres seguidas de una coma cada una. 
 * @param ficheroALeer
 * @return Un Hashmap con cada clave, el nombre que precede a ":" y el valor será una lista con los elementos separados por ","
 * @throws UnsupportedEncodingException
 * @throws FileNotFoundException
 * @throws IOException
 * @see <a href=https://docs.oracle.com/javase/7/docs/api/java/util/regex/Pattern.html>Pattern</a>
 */
	@SuppressWarnings("unchecked")
	public static  Map<String,ArrayList> leerElementoPreferencias(String ficheroALeer) 
		    throws UnsupportedEncodingException, FileNotFoundException, IOException{
		
		boolean primeraLinea=false;
		boolean errorLinea=false;
		int numeroElementosPrimeraLinea=0;
		
		Map<String,ArrayList> mapa=new HashMap();

		    FileInputStream fis =new FileInputStream(ficheroALeer);
		    
		    //para ficheros con símbolos propios del español, 
		    //utilizamos la codificación "ISO-8859-1"
		    InputStreamReader isr = new InputStreamReader(fis, "UTF8"); 
		    BufferedReader br = new BufferedReader(isr);
		    
		    //Leemos la primera línea
		    String linea=br.readLine();	
		    primeraLinea=true;
		    int numeroLinea=0;
		    
		    //Leemos cada línea
		    while(linea!=null){
		    	 
			    	numeroLinea++;
			    	
			    	//Creamos el patron de la expresión regular que reconocerá las líneas
			    	 Pattern pat = Pattern.compile("[\\w]+:[\\w,]+");
			    	 Matcher mat = pat.matcher(linea);
			    	 
			    	 //Si no se cumple el patrón se marca un error de línea y se muestra un mensaje de error
			    	 if( !mat.matches()){
			    		
					    		errorLinea=true;
					    		System.err.println(ficheroALeer+" no tiene el formato correcto en la linea "+numeroLinea+"\n"+linea);
					    		
					    		//Leemos siguiente linea
					    		linea=br.readLine();
			    	 }else{
						    	 
						    		 
						    	//Separamos por el símbolo : la línea en dos Strings
						    	
						        String[] split= linea.split(":");
						        String elemento = split[0];			       
						        String lista=split[1];
						        
						        //Volvemos a separar, ahora cada uno de los favoritos con las comas
						        String[] listaFavoritosSeparados=lista.split(",");
						        
						        //Numero de elementos obtenidos
						        int numeroElementos=listaFavoritosSeparados.length;
						        
						        //Si es la primera linea guardamos ese numero de elementos
						        if (primeraLinea){
						        	numeroElementosPrimeraLinea=numeroElementos;
						        	primeraLinea=false;
						        }
						        //Si no, comprobamos que coinciden siempre el número de elementos y si no arrojamos una excepción
						        else{
						        	if (numeroElementosPrimeraLinea!=numeroElementos){
						        		errorLinea=true;
							    		System.err.println(ficheroALeer+" no es el tipo de archivo correcto.No coinciden el número de elementos con la primera fila en la línea "+numeroLinea+"\n"+linea);
						        	}
						        }
						        						        
						        //Lo transformamos en una lista
						        List<String> lista2 = Arrays.asList(listaFavoritosSeparados);
						        
						        
						        //Creamos un ArrayList con el contenido de la lista
						        ArrayList<String> listaArray = new ArrayList<String>(lista2);
						        
						        //Lo añadimos a nuestro mapa, con el elemento como clave
						        mapa.put(elemento, listaArray);
						        
						        //Leemos la siguiente línea
						        linea=br.readLine();
				    }
		    }
		    //Si se ha producido algún error en alguna línea se arroja una excepción
		    if  (errorLinea){
	        	//Cerramos el buffer,el stream y el fichero
			    br.close();
			    isr.close();
			    fis.close();
	    		throw new IOException(ficheroALeer+" no es el tipo de archivo correcto.");
	        }
		    
		    
		    //Finalización correcta:Cerramos el buffer,el stream y el fichero
		    br.close();
		    isr.close();
		    fis.close();
		    
		    System.out.println("Leido archivo "+ficheroALeer);
		    return mapa;

		}
	/**
	 * Lee el fichero de nombre "ficheroALeer" con una serie de parejas separadas por ":"
	 * <p>Se espera que cada línea del fichero siga la expresión regular [\\w]+:[\\w]+</p>
	 * @param ficheroALeer
	 * @return retorna un mapa con las parejas leidas en las que el primer elemento de cada pareja es el valor y el segundo la clave
	 * @throws IOException
	 *@see <a href=https://docs.oracle.com/javase/7/docs/api/java/util/regex/Pattern.html>Pattern</a>
	 */
	public static  Map<String,String> leerParejasEstablesFile(String ficheroALeer) throws IOException {
		Map<String,String> mapa=new HashMap<String, String>();

	    FileInputStream fis =new FileInputStream(ficheroALeer);
	    
	    //para ficheros con símbolos propios del español, 
	    //utilizamos la codificación "ISO-8859-1"
	    InputStreamReader isr = new InputStreamReader(fis, "UTF8"); 
	    BufferedReader br = new BufferedReader(isr);
	    
	    //Leemos la primera línea
	    String linea=br.readLine();			    
	    int numeroLinea=0;
	    boolean error=false;
	    
	    //Recorremos cada línea
	    while(linea!=null){
	    	
	    	 numeroLinea++;
	    	 
	    	//Creamos el patron de la expresión regular que reconocerá las líneas
	    	 Pattern pat = Pattern.compile("[\\w]+:[\\w]+");
	    	 Matcher mat = pat.matcher(linea);
	    	 
	    	 //Si no coincide se muestra un error, se marca error y se pasa a la siguiente línea
	    	 if( !mat.matches()){
	    		 error=true;
	    		 System.err.println(ficheroALeer+" no tiene el formato correcto en la linea "+numeroLinea+"\n"+linea);
	    		//Leemos la siguiente línea
	 	        linea=br.readLine();
	    	 }
	    	 
	    	 else {
			    	//Separamos por el símbolo : la línea en dos Strings
			    	
			        String[] split= linea.split(":");
			        String X= split[0];			       
			        String Y=split[1];
			        
			        //Insertamos en el mapa
			        mapa.put(Y, X);
		
			        //Leemos la siguiente línea
			        linea=br.readLine();
			    	 }
	    }
	    
	    
	    //Cerramos el buffer,el streamreader y el fichero
	    br.close();
	    isr.close();
	    fis.close();
	    
	    //Si ha habido algún error se genera una excepción
	    if (error) {
    		throw new IOException(ficheroALeer+" no es el tipo de archivo correcto.");
	    }else{
	    	
	    System.out.println("Leido archivo "+ficheroALeer);
	    }
	    
		return mapa;
	}
	/**
	 * <p>Empareja los elementos de dos grupos dadas sus preferencias según el algoritmo de Gale-Shapley</p>
	 * <p>A medida que forma las parejas añade <strong>la última pareja no estable de cada X</strong> a noEmparejados</p>
	 * @param  elementosX Map con los elementos y preferencias de una clase
	 * @param elementosY Mapcon los elementos y preferencias de la otra clase
	 * @param noEmparejados ArrayList con los elementos no emparejados
	 * @return Mapa con parejas estables. Las claves serán los nombres de elementosY. Los valores los de X
	 */	
@SuppressWarnings("unchecked")
public static Map emparejarGaleShapley(Map elementosX, Map elementosY, ArrayList noEmparejados){
		
	//Iniciamos el contador de tiempo		  
	  long time_start = System.currentTimeMillis();
	  //Creamos un nuevo mapa para las parejas formadas
	  Map parejasFormadas = new HashMap();
	  
	  	//Elementos xLibresList representa los elementosX todavía no emparejados, inicialmente son todos
		ArrayList xLibresList = new ArrayList();
		
		//Recorremos los elementosX y los añadimos a la lista de elementos libres X
		Set xSet= elementosX.keySet(); //Set con las claves de elementosX, es decir, todos los localname de los elementos X
		java.util.Iterator<String> it = xSet.iterator();
		while (it.hasNext()){
			xLibresList.add(it.next());
			
		}
		
		//Mientras la lista de elementos no está libre la recorremos e intentamos emparejar a cada X con su favorito Y
		while (!xLibresList.isEmpty()){
			System.out.println("emparejando");
			
				//Eliminamos de la lista de libres
				String currentX= (String) xLibresList.remove(0);
				 //Obtenemos la lista de parejas del elemento completo
			   ArrayList parejasPreferidasActual = (ArrayList) elementosX.get(currentX);
			    
			    
			    
			    Iterator i=parejasPreferidasActual.iterator();
			    String y;//posible pareja de currentX
			    
			    //Recorremos la lista de parejas de currentX
			    while(i.hasNext()){
			    	y=(String) i.next();//pareja de CurrentX en cada momento
			    	if(parejasFormadas.get(y) == null) { // Este elemtentoY no está emparejado
						//Se emparejan los dos
		                parejasFormadas.put(y, currentX);
		                break;
		                
		                
		               /*Si el elementoY sí tiene pareja 
		                se comprueba si esta pareja está antes en su lista de preferencias que currentX o no
		                Si la pareja actual está antes se mantiene esa pareja.
		                Si, en cambio, y prefiere a currentX cambia su pareja por él
		                y la pareja anterior se añade a la lista de elementos libres
		               */
		            }else {
		                String otherX = (String) parejasFormadas.get(y);
		                ArrayList parejasDeY = ((ArrayList) elementosY.get(y));
		               
		                if(parejasDeY.indexOf(currentX) < parejasDeY.indexOf(otherX)){
		                    //Este y prefiere a currentX antes que con quien está
		                    parejasFormadas.put(y, currentX);//Se forma la pareja
		                    Pareja noPareja=new Pareja(y,otherX);
		                    
		                    if (!checkListaContainsPareja(noEmparejados,noPareja))
		                    noEmparejados.add(noPareja);//Se añade a la lista de parejas no estables
		                    
		                    xLibresList.add(otherX);//Se añade otherX a la lista de elementos libres
		                    break;
		                }
		            }
			   
			    }
			    
		}
		
		//Finalizamos el contador de tiempo
  	 long time_end = System.currentTimeMillis();
  	 
  	 //Imprimimos el tiempo empleado en el emparejamiento
  	 System.out.println("\n\nEl emparejado ha tomado "+ ( time_end - time_start ) +" millisegundos");
		return parejasFormadas;
			
			
		
	}

/**
 * <p>Empareja los elementos de dos grupos dadas sus preferencias según el algoritmo de Gale-Shapley</p>
 * <p>A medida que forma las parejas añade <strong>todas las parejas que se van encontrando</strong> a noEmparejados</p>
 * @param  elementosX Map con los elementos y preferencias de una clase
 * @param elementosY Mapcon los elementos y preferencias de la otra clase
 * @param noEmparejados ArrayList con los elementos no emparejados
 * @return Mapa con parejas estables. Las claves serán los nombres de elementosY. Los valores los de X
 */	
@SuppressWarnings("unchecked")
public static Map emparejarGaleShapleyCompleto(Map elementosX, Map elementosY, ArrayList noEmparejados){
	
//Iniciamos el contador de tiempo		  
  long time_start = System.currentTimeMillis();
  //Creamos un nuevo mapa para las parejas formadas
  Map parejasFormadas = new HashMap();
  
  	//Elementos xLibresList representa los elementosX todavía no emparejados, inicialmente son todos
	ArrayList xLibresList = new ArrayList();
	
	//Recorremos los elementosX y los añadimos a la lista de elementos libres X
	Set xSet= elementosX.keySet(); //Set con las claves de elementosX, es decir, todos los localname de los elementos X
	java.util.Iterator<String> it = xSet.iterator();
	while (it.hasNext()){
		xLibresList.add(it.next());
		
	}
	
	//Mientras la lista de elementos no está libre la recorremos e intentamos emparejar a cada X con su favorito Y
	while (!xLibresList.isEmpty()){
		System.out.println("emparejando");
			//Eliminamos de la lista de libres
			String currentX= (String) xLibresList.remove(0);
			 //Obtenemos la lista de parejas del elemento completo
		   ArrayList parejasPreferidasActual = (ArrayList) elementosX.get(currentX);
		    
		   
		    
		    
		    Iterator i=parejasPreferidasActual.iterator();
		    String y;//posible pareja de currentX
		    
		    //Recorremos la lista de parejas de currentX
		    while(i.hasNext()){
		    	y=(String) i.next();//pareja de CurrentX en cada momento
		    	if(parejasFormadas.get(y) == null) { // Este elementoY no está emparejado
					//Se emparejan los dos
	                parejasFormadas.put(y, currentX);
	                break;
	               /*Si el elementoY sí tiene pareja 
	                se comprueba si esta pareja está antes en su lista de preferencias que currentX o no
	                Si la pareja actual está antes se mantiene esa pareja.
	                Si en cambio y prefiere a currentX cambia su pareja por él
	                y la pareja anterior se añade a la lista de elementos libres
	               */
	            }else {
	                String otherX = (String) parejasFormadas.get(y);
	                ArrayList parejasDeY = ((ArrayList) elementosY.get(y));
	               
	                
	                if(parejasDeY.indexOf(currentX) < parejasDeY.indexOf(otherX)){
	                    //Este y prefiere a currentX antes que con quien está
	                    parejasFormadas.put(y, currentX);//Se forma la pareja
	                    Pareja noPareja=new Pareja(y,otherX);
	                    if (!checkListaContainsPareja(noEmparejados,noPareja)){
	                    noEmparejados.add(noPareja);
	                    }
	                    xLibresList.add(otherX);//Se añade otherX a la lista de elementos libres
	                    
	                    break;
	                }else {
	                	Pareja noPareja=new Pareja(y,currentX);
	                	if (!checkListaContainsPareja(noEmparejados,noPareja)){
	                    noEmparejados.add(noPareja);//Añadimos a la lista de no emparejados la pareja que no se ha llegado a formar
	                	}
	                	}
	            }
		   
		    }
		    
	}
	
	//Finalizamos el contador de tiempo
	 long time_end = System.currentTimeMillis();
	 
	 long time=time_end-time_start;
	 
	 //Imprimimos el tiempo empleado en el emparejamiento
	 System.out.println("\n\nEl emparejado ha tomado "+ time +" milisegundos");
	 
	 return parejasFormadas;
		
		
	
}
/**
 * Muestra las parejas de un Mapa con un pTexto inicialmente
 * @param emparejados Map con un grupo de parejas
 * @param pTexto     String texto que se mostrará como inicio
 */
public static void verParejas(Map emparejados,String pTexto) {
	//Control emparejados
		System.out.println(pTexto);
			Iterator i=emparejados.keySet().iterator();
			
			while (i.hasNext()){
				String elegido = (String) i.next();
				String elector=(String) emparejados.get(elegido);
				System.out.println(elector+","+elegido);
			}
		
			System.out.println("\n\n PAREJAS: "+emparejados.size());
			System.out.println("\n\n");
	
}
/**
 * Muestra las parejas de un ArrayList y un texto inicial pTexto
 * @param emparejados  ArrayList con un grupo de parejas
 * @param pTexto       String texto que se mostrará como inicio
 */
public static void verParejas(ArrayList emparejados,String pTexto) {
	//Control emparejados
		System.out.println(pTexto);
			Iterator i=emparejados.iterator();
			
			while (i.hasNext()){
				Pareja pareja = (Pareja) i.next();
				String x=pareja.getX();
				String y=pareja.getY();
				System.out.println(x+","+y);
			}
		
			System.out.println("\n\n PAREJAS: "+emparejados.size());
			System.out.println("\n\n");
	
}
/**
 * <p>Función que dados dos mapas de elementos con las listas de preferencias de parejas de cada uno muestra en pantalla las parejas preferidas de cada elemento de mayor a menor</p>
 * <p>En primer lugar la clave	y luego el valor: la lista de preferencias</p>
 * @param elementosX Mapa con los elementos  y sus preferencias de una clase </p>	
 * @param elementosY Mapa con los elementos y sus preferencias de la otra clase
 */
public static void  verPreferencias(Map elementosX,Map elementosY){
  //Control
 System.out.println("\n\n...........................................\n\n   LISTAS DE PREFERENCIAS DE LAS PAREJAS\n...........................................\n");
	Iterator i = elementosX.keySet().iterator();
	while (i.hasNext()){
		String agente = (String) i.next();
		
		ArrayList a=(ArrayList) elementosX.get(agente);
		
		
		System.out.println(agente+": "+a);						
	}
	//Control
	System.out.println("\n........................\n");
	Iterator i3 = elementosY.keySet().iterator();
	while (i3.hasNext()){
		String agente = (String) i3.next();
		
		ArrayList a=(ArrayList) elementosY.get(agente);
		
		
		System.out.println(agente+": "+a);						
	}
	System.out.println("\n\n");
}
/**
 * Escribe un archivo de texto con el nombre nameFile y el texto pTexto
 * @param pTexto String que se incluirá en el archivo
 * @param nameFile String nombre del archivo
 * @param continuarEnFichero boolean indica si se continuará escribiendo en el archivo (true) o si se reescribirá únicamente con pTexto
 */
public static void createFile(String pTexto, String nameFile, Boolean continuarEnFichero){
	//Creamos un Nuevo objeto FileWriter dandole
    //como parámetros la ruta con el nombre del fichero y si se reescribirá o continuará en el archivo existente
    FileWriter fichero;
	try {
		fichero = new FileWriter(nameFile,continuarEnFichero);
	
    //Creamos un buffer para él
    BufferedWriter bw = new BufferedWriter(fichero);
    //Creamos un printwriter para ese buffer
	  PrintWriter out = new PrintWriter(bw);
	 out.print(pTexto);
	  
    
	 //Cerramos 
	 out.close();
	 bw.close();		   
    fichero.close();
	  }
    catch (IOException e) {
			e.printStackTrace();
		}
	
}
/**
 * Función que comprueba si una lista contiene una pareja
 * @param lista
 * @param pareja
 * @return boolean , true si la contiene y false en caso contrario
 */
private static boolean checkListaContainsPareja(ArrayList lista,Pareja pareja){
	boolean resultado = false;
	Iterator it=lista.iterator();
	while (it.hasNext()){
		Pareja p=(Pareja) it.next();
		
		if (p.getX().equals(pareja.getX())&&p.getY().equals(pareja.getY())){
			
			return true;
		}
			
	}
	return resultado;
	
}
}

