package tfgMarriageStable;

import jade.util.leap.ArrayList;
import jade.util.leap.Serializable;
/**
 * Clase que agrupa el LocalName de un elemento con sus características, sus preferencias, su lista de parejas y la clase a la que pertenece
 * Al ser serializable se puede enviar como contenido de un mensaje
 * @author Alberto Hueso Alonso
 *@since 06-12-2017
 *@see Elemento
 *@see Caracteristica
 *
 */
public class ElementoCompleto implements Serializable {
	/**
	 * Constante para serializar
	 */
	private static final long serialVersionUID = 6511753219944594717L;
	/**
	 * LocalName del elemento
	 */
	private String agent;
	/**
	 * Lista de parejas del elemento, el orden indica la preferencia de las parejas de mayor a menor
	 */
	private jade.util.leap.ArrayList parejas;
	/**
	 * Lista de características
	 */
	private jade.util.leap.ArrayList caracteristicas;	
	/**
	 * Lista de preferencias
	 */
	jade.util.leap.ArrayList preferencias;	
	
	private String clase;//Clase del elemento;
		/**
		 * Constructor de un ElementoCompleto
		 * @param agenteLocalName  LocalName del agente que se completa
		 * @param caracteristicasP  características del elemento
		 * @param preferenciasP   preferencias del elemento
		 * @param listaParejas    lista de parejas del elemento
		 * @param claseP		 String que representa la clase
		 */
		public ElementoCompleto(String agenteLocalName, ArrayList caracteristicasP, ArrayList preferenciasP, ArrayList listaParejas,String claseP  ){
			this.agent=agenteLocalName;
			this.caracteristicas=caracteristicasP;
			this.preferencias=preferenciasP;
			this.parejas=listaParejas;
			this.clase=claseP;
			
		}
		/**
		 * Obtiene el LocalName del ElementoCompleto
		 * @return Strig con el LocalName
		 */
		public String getAgent(){
			return this.agent;
		}
		
		/**
		 * Obtiene las características del agente completo		 * 
		 * @return ArrayList con las características
		 */
		public ArrayList getCaracteristicas(){
			return this.caracteristicas;
			
		}
		/**
		 * Obtiene las preferencias del agente completo
		 * @return ArrayList con las preferencias
		 */
		public ArrayList getPreferencias(){
			return this.preferencias;
		}
		/**
		 * Obtiene la lista de parejas de ElementoCompleto
		 * @return lista de parejas del agente ArrayList
		 */
		public ArrayList getListaParejas(){
			return this.parejas;
		}
		
		/**
		 * Obtiene un String con la clase a la que pertenece el Elemento que representa
		 * @return String con la clase
		 */
		public String getClase(){
			
			return this.clase;
			
		}

}
