package tfgMarriageStable;

import jade.core.AID;


/**
 * <p>Clase que implementa Comparable<p>
 * <p>Nos permite comparar dos instancias elementos en función de la valoración realizada del mismo por otro elemento
 * </p>
 * @author Alberto Hueso Alonso
 *@since 06/12/2017
 *@see Elemento
 */
public  class ElementoValorado implements Comparable<ElementoValorado>{
	//Características del agente
		/**
		 * AID del elemento que se valora y representa ElementoValorado
		 */
		private AID agentAID;		
		/**
		 * Valoración del Elemento por parte de otro Elemento
		 */
		private float valoracion;	
/**
 * Constructor de ElementoValorado a partir de un AID y una valoración float v
 * @param agenteAID  AID del elemento que se valora
 * @param v			valor que se asigna al elemento valorado
 */
public ElementoValorado(AID agenteAID, float v){
	 
	this.agentAID=agenteAID;
	this.valoracion=v;
}

/**
 * Compara el ElementoValorado que ejecuta la función con el ElementoValorado a
 * Según las valoraciones de ambos. 
 * @param a
 * return 0 si son iguales, 1 si el que lo ejecuta tiene una mayor valoración y -1 si a tiene una menor valoracion
 */
public int compareTo(ElementoValorado a) {
	int resultado=0;//Si son iguales se retorna 0
	
	if (this.valoracion>a.valoracion){
		resultado=1;
	}
	if (this.valoracion<a.valoracion){
		resultado=-1;
	}
	return resultado;
}

/**
 * Devuelve el AID del agente
 * @return AID del agente 
 */
public AID getAID(){
	
	return this.agentAID;
}
/**
 * Devuelve la valoración del agente
 * @return float con la valoración
 */
public float getValoracion(){
	
	return this.valoracion;
}
/**
 * Actualiza la valoración del agente a nuevoValor
 * @param nuevoValor float con el nuevo valor */
public void updateValoracion(float nuevoValor){
	this.valoracion=nuevoValor;
}
}
