package tfgMarriageStable;

import jade.util.leap.ArrayList;


/**
* Clase Y que utilizamos para sobreescribir el método IniciarPreferencias() y modular las preferencias
* si la variables <i>moduladas</i> es true
*@since 10/12/2017
*/
public class ElementoY extends Elemento{

	/**
	 * Constante para serializar
	 */
	private static final long serialVersionUID = -250401995398029896L;
	
	/**
     * <p>Función que crea las preferencias del elemento</p>
     * <p>Hasta igualar el número de características añade a una lista de Caracteristicas
     * el nombre de una preferencia ("caracteristica"+numero+Preferencia)
     * junto con el valor calculado como un número entre 0 y 10</p>
     * <p>Obsérvese que una preferencia por otra característica no deja de ser una característica también. Indica el valor que el agente da a esa característica</p>   
     *<p>Multiplica cada valor aleatorio obtenido por el número de la preferencia +1, es decir, da a las primeras preferencias valores más bajos y a las últimas más altos</p>
     * @return ArrayList con la lista de valores de las preferencias por otras características que tiene el agente
     * @see Funciones#getMultiplicador
     * @see Caracteristica
     */
	protected jade.util.leap.ArrayList iniciarPreferencias(){
    	
	   	 jade.util.leap.ArrayList preferencias=new ArrayList();
	   	
	   	 int i=0;
	   	 while (i<this.numeroCaracteristicas){
	   		 String nombre="caracteristica";
	   		 nombre=nombre+i+"Preferencia";
	   		 float  valor=Funciones.getMultiplicador();//Le damos un valor aleatorio
	   		 
	   		 //Si es necesario, modulamos las preferencias
	   		 if (moduladas){
	   		 //Damos a las primeras preferencias valores más bajos y a las últimas, más altos
	   		
	   		 valor=(i+1)*valor;
	   		 }
	   		 
	   		 Caracteristica preferencia=new Caracteristica(nombre,valor);
	   		 preferencias.add(preferencia);
	   		 i++;
	   		 
	   		 //Control
	   		 System.out.println(this.getLocalName()+": "+nombre+" "+valor);
	   	 }
			return preferencias;
	   }
}

