package tfgMarriageStable;

import jade.util.leap.Map;
/**
 * <p>Clase que extiende Emparejador</p>
 * <p>Reescribe la función emparejar() utilizando el algoritmo de GaleShapley</p> * 
 * @author Alberto Hueso Alonso
 *@since 06/12/2017
 *@see Funciones#emparejarGaleShapley(Map, Map, jade.util.leap.ArrayList)
 *@see Funciones#createFile(String, String, Boolean)
 */
public class GaleShapley extends Emparejador {

	private static final long serialVersionUID = -219891314783968534L;

	/**
	 * Empareja los mapas de elementos X e Y utilizando el algoritmo de Gale Shapley
	 */
	protected Map emparejar() {
		  
		 //Ejecutamos el código de la función en el elemento padre (imprimir un mensaje)
		 super.emparejar();
		//Iniciamos el contador de tiempo		  
		  long time_start = System.currentTimeMillis();
		  
		 //Efectuamos el emparejamiento 
		 Map emparejadas=Funciones.emparejarGaleShapley(elementosX, elementosY, noEmparejados);
		 
		 //Finalizamos el contador 
		 long time_end = System.currentTimeMillis();
		 
		 String mensaje=elementosX.size()+","+(time_end-time_start)+","+iteracion+",\r\n";		 
		 //Guardamos los datos en el archivo de tiemposEmparejamientos
		 Funciones.createFile(mensaje,"tiemposEmparejamientos.csv",true);
		 
		 //Retornamos las parejas emparejadas según el algoritmo de Gale-Shapley
		return emparejadas;
			
			
		}
}
