package tfgMarriageStable;

import jade.util.leap.Map;
/**
 * <p>Clase que extiende Emparejador</p>
 * <p>Reescribe la función emparejar() utilizando el algoritmo de GaleShapley versión completa(guarda en noEmparejados todas las parejas que se determinan no estables, no solo las parejas que se rompen, sino las que no llegan a formarse porque un elemento prefiere a su pareja provisional antes que a un pretendiente</p> * 
 * @author Alberto Hueso Alonso
 *@since 06/12/2017
 *@see Funciones#emparejarGaleShapleyCompleto(Map, Map, jade.util.leap.ArrayList)
 *@see Funciones#createFile(String, String, Boolean)
 */
public class GaleShapleyCompleto extends Emparejador {

	private static final long serialVersionUID = -219891314783968534L;

	/**
	 * Empareja los mapas de elementos X e Y utilizando el algoritmo de Gale Shapley
	 * 	 */
	protected Map emparejar() {
		  
		 //Ejecutamos el código de la función en el elemento padre (imprimir un mensaje)
		 super.emparejar();
		 
		 //Iniciamos el contador de tiempo		
		  long time_start = System.currentTimeMillis();
		  
		 //Efectuamos el emparejamiento
		 Map emparejadas=Funciones.emparejarGaleShapleyCompleto(elementosX, elementosY, noEmparejados);
		
		 //Terminamos el contador de tiempo
		 long time_end = System.currentTimeMillis();
		 
		 String mensaje=elementosX.size()+","+(time_end-time_start)+","+iteracion+",Completo\r\n";		 
		 //Guardamos el mensaje en el archivo de tiemposEmparejamientos
		 Funciones.createFile(mensaje,"tiemposEmparejamientos.csv",true);
		 
		 //Retornamos las parejas emparejadas según el algoritmo de Gale-Shapley Completo
		return emparejadas;
			
			
		}
}
