package tfgMarriageStable;

import java.util.Arrays;
import java.util.Collections;
import jade.core.AID;
import jade.util.leap.ArrayList;


/**
 * Clase que extiende jade.util.leap.ArrayList para guardar una serie de ElementoValorado
 * Añadimos el métotodo getIndexAID(AID agentAID) que nos permite
 * encontrar la posición de un elemento de una lista de la clase ElementoValorado
 * a partir de su AID
 * @author Alberto Hueso Alonso
 *
 */
public class ListaParejas extends jade.util.leap.ArrayList {
	

	private static final long serialVersionUID = -7079940916398585720L;

	/**
	 * Nos permite encontrar la posición de un elemento de la lista de la clase ElementoValorado
 * 		a partir de su AID
	 * @param agentAID
	 * @return int El índice en el que se encuentra el elemento
	 * @throws ExcepcionAgentNotFound
	 */
	public int getIndexAID(AID agentAID) throws ExcepcionAgentNotFound{
	int 	i=0;
	
		//Recorremos la lista y obtenemos un ElementoValorado cada vez
		while(i<this.size()){
			ElementoValorado actual=(ElementoValorado) this.get(i);
			//Comparamos con el AID que buscamos. Si coinciden retornamos el index
			if (agentAID.equals(actual.getAID())){
				return i;
			}else	i++;		}//Si no, pasamos al siguiente
		
		throw new ExcepcionAgentNotFound("No se ha encontrado el agente en la lista");
			
	}
	
	/**
	 * Función que ordena una ListaParejas de mayores valoraciones a menores.
	 */
	public ListaParejas ordenarMayorAMenor(){
		
		/*Creamos un array de objetos y lo ordenamos
		Como son de la clase ElementoValorado utilizará el criterio de comparación implementado en esa clase*/
		 Object[] miArray = this.toArray();
		 Arrays.sort(miArray);	
		 
		 //Invertimos el orden del array
		 java.util.List<Object> myList = Arrays.asList(miArray);
	      Collections.reverse(myList);
	      
		
	   /*Creamos una nueva ListaParejas, añadimos los elementos del array
	    * por lo tanto estará ordenada y la retornamos
	    */
		ListaParejas ordenada=new ListaParejas();
		int i=0;
		while (i<miArray.length){
			ElementoValorado a=(ElementoValorado) miArray[i];
			ordenada.add(a);
			i++;
		}
		return ordenada;				
	}

	/**
	 * Convierte la lista en una lista equivalente pero solo con los AID de los elementos,
	 * sin sus valoraciones
	 * @return ArrayList con AIDs, sin sus valoraciones.
	 */
	public jade.util.leap.ArrayList toAID_List(){
		ArrayList newList = new jade.util.leap.ArrayList();
		
		int i=0;
		while (i<this.size()){
			ElementoValorado a=(ElementoValorado) this.get(i);
			newList.add(a.getAID());
			i++;
			
		}
		
		return newList;	
		
		
	}
	
	/**
	 * Convierte la lista en una lista equivalente pero solo con los LocalName de los agentes
	 * @return ArrayList de Strings con los local Name de las parejas
	 */
	public jade.util.leap.ArrayList toLocalName_List(){
		ArrayList newList = new jade.util.leap.ArrayList();
		
		int i=0;
		while (i<this.size()){
			ElementoValorado a=(ElementoValorado) this.get(i);
			newList.add(a.getAID().getLocalName());
			i++;
		}
		return newList;	
		
		
	}
}
